{Object_Title_and_Purpose}


CON
        _clkmode = xtal1 + pll16x                                               'Standard clock mode * crystal frequency = 80 MHz
        _xinfreq = 5_000_000

        ' Pin definitions
        #0,   uSDMasDO, uSDMasCLK, uSDMasDI, uSDMasCS,{
  }     uSDTar1DO, uSDTar1CLK, uSDTar1DI, uSDTar1CS,{
  }     uSDTar2DO, uSDTar2CLK, uSDTar2DI, uSDTar2CS,{
  }     uSDTar3DO, uSDTar3CLK, uSDTar3DI, uSDTar3CS

VAR
  long  buf[512/4] ' a long-aligned block of 512-bytes (SD size)
   
OBJ
  sd[1+3]       : "safe_spi_2_7"                        ' using VAR to get 4 copies in 4 cogs

PUB Demo
  do_copy( (64 << 20) / 512 ) ' copy 64MB

PUB do_copy( N_blocks_of_512 ) : i

  ' read from object 0
  sd.start( uSDMasDO )
  ' write to objects 1-3
  sd[1].start( uSDTar1DO )
  sd[2].start( uSDTar2DO )
  sd[3].start( uSDTar3DO )

  ' do the copy
  repeat i from 0 to N_blocks_of_512-1
    sd.readblock( i, @buf )
    sd[1].writeblock( i, @buf )
    sd[2].writeblock( i, @buf )
    sd[3].writeblock( i, @buf )
  
  ' done
  repeat i from 0 to 3
    sd[i].stop

PRI private_method_name


DAT
name    byte  "string_data",0        
        